#include "extdll.h"
#include "dllapi.h"
#include "meta_api.h"
#include "plugin.h"
#include "shake.h"
#include "cbase.h"

int gmsgDeathMsg = 0;

void UTIL_LogPrintf( char *fmt, ... )
{
   va_list      argptr;
   static char  string[1024];
   
   va_start ( argptr, fmt );
   vsprintf ( string, fmt, argptr );
   va_end   ( argptr );

   // Print to server console
   ALERT( at_logged, "%s", string );
}

//make sure there is a TF in range.
int UTIL_HasAdvTF(edict_t *pEntity)
{
	CBaseEntity *pOther = NULL;
	while(pOther = UTIL_FindEntityByClassname(pOther, "team_advturretfactory"))	{
		if((pOther->pev->origin - pEntity->v.origin).LengthSquared() < (600*600))//I think this range is about right.
			if(pOther->pev->team == pEntity->v.team)
				return 1;
	}
	return 0;
}

int UTIL_HolsterWeapon(edict_t *pEntity)
{
	pEntity->v.weaponmodel = 0;
	pEntity->v.viewmodel = 0;
	PlayerData[ENTINDEX(pEntity)].m_WeaponHolstered = 1;
	return 1;
}

int UTIL_DeployWeapon(edict_t *pEntity)
{
	PlayerData[ENTINDEX(pEntity)].m_WeaponHolstered = 0;
	
	//Select the best weapon they got.
	CLIENT_COMMAND(pEntity, "use weapon_knife\n");
	CLIENT_COMMAND(pEntity, "use weapon_pistol\n");
	CLIENT_COMMAND(pEntity, "use weapon_welder\n");
	CLIENT_COMMAND(pEntity, "use weapon_mine\n");
	CLIENT_COMMAND(pEntity, "use weapon_machinegun\n");
	CLIENT_COMMAND(pEntity, "use weapon_shotgun\n");
	CLIENT_COMMAND(pEntity, "use weapon_heavymachinegun\n");
	CLIENT_COMMAND(pEntity, "use weapon_grenadegun\n");
	return 1;
}

bool UTIL_IsBuilt(edict_t *pent)
{
	if(pent->v.fuser1 >= 1000 || FStrEq(STRING(pent->v.classname), "team_advarmory"))//fuser1 ALWAYS has to be equal or greater than 1000
	{
		if(pent->v.health)//if it has health
			return true;
		else
		{
			pent->v.fuser1 = 0;
			return false;
		}
	}
	return false;
}


void UTIL_ScreenShake( const Vector &center, float amplitude, float frequency, float duration, float radius )
{
	int			i;
	float		localAmplitude;
	ScreenShake	shake;

	shake.duration = FixedUnsigned16( duration, 1<<12 );		// 4.12 fixed
	shake.frequency = FixedUnsigned16( frequency, 1<<8 );	// 8.8 fixed

	for ( i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *pPlayer = UTIL_PlayerByIndex( i );

		if (!pPlayer)	
			continue;

		localAmplitude = 0;

		if ( radius <= 0 )
			localAmplitude = amplitude;
		else
		{
			Vector delta = center - pPlayer->pev->origin;
			float distance = delta.Length();
	
			// Had to get rid of this falloff - it didn't work well
			if ( distance < radius )
				localAmplitude = amplitude;//radius - distance;
		}
		if ( localAmplitude )
		{
			shake.amplitude = FixedUnsigned16( localAmplitude, 1<<12 );		// 4.12 fixed
			
			MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG("ScreenShake", -1), NULL, pPlayer->edict() );		// use the magic #1 for "one client"
				
				WRITE_SHORT( shake.amplitude );				// shake amount
				WRITE_SHORT( shake.duration );				// shake lasts this long
				WRITE_SHORT( shake.frequency );				// shake noise frequency

			MESSAGE_END();
		}
	}
}


CBaseEntity *UTIL_FindEntityInSphere( CBaseEntity *pStartEntity, const Vector &vecCenter, float flRadius )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_IN_SPHERE( pentEntity, vecCenter, flRadius);

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}


CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}

CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName )
{
	return UTIL_FindEntityByString( pStartEntity, "classname", szName );
}

CBaseEntity *UTIL_FindEntityByTargetname( CBaseEntity *pStartEntity, const char *szName )
{
	return UTIL_FindEntityByString( pStartEntity, "targetname", szName );
}

void UTIL_MakeVectors( const Vector &vecAngles )
{
   MAKE_VECTORS( vecAngles );
}

CBaseEntity	*UTIL_PlayerByIndex( int playerIndex )
{
	CBaseEntity *pPlayer = NULL;

	if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients )
	{
		edict_t *pPlayerEdict = INDEXENT( playerIndex );
		if ( pPlayerEdict && !pPlayerEdict->free )
		{
			pPlayer = CBaseEntity::Instance( pPlayerEdict );
		}
	}
	
	return pPlayer;
}

//My damage code, If you use this in your own plugin you _MUST_ release the source, as this code is GPL just like the rest of this code.
//Dont forget to block the engune functions, otherwise you get 2 log lines and 2 death messages. This code is my baby!
int UTIL_Damage(edict_t *pVictim, edict_t *pAttacker, float Damage, char *Weapon)
{
	SAFE_USER_MSG(gmsgDeathMsg, "DeathMsg", -1);

	if(FStrEq(STRING(pVictim->v.classname), "player") && FStrEq(STRING(pAttacker->v.classname), "player"))//make sure its a player vs a player.
	{
		if(pVictim->v.takedamage == 0 
			|| pVictim->v.deadflag 
			|| !pVictim->v.health)
			return 0;

		if(pVictim->v.armorvalue)//Do they have armor?
		{
			
			float flRatio;
			float flBonus;
			
			flBonus = 0.5;
			flRatio = 0.3;//70%
			
			float flNew = Damage * flRatio;
			
			float flArmor;
			
			flArmor = (Damage - flNew) * flBonus;
			
			// Does this use more armor than we have?
			if (flArmor > pVictim->v.armorvalue)
			{
				flArmor = pVictim->v.armorvalue;
				flArmor *= (1/flBonus);
				flNew = Damage - flArmor;
				pVictim->v.armorvalue = 0;
			}
			else
			{
				pVictim->v.armorvalue -= flArmor;
			}
			Damage = flNew;
		}

		if (pVictim->v.health - Damage <= 0)
		{
			if (gmsgDeathMsg == 0)
				gmsgDeathMsg = REG_USER_MSG("DeathMsg",-1);
			
			if(pVictim->v.team != pAttacker->v.team && pVictim != pAttacker)
			{
				MESSAGE_BEGIN( MSG_ALL, gmsgDeathMsg );
				WRITE_BYTE( ENTINDEX(pAttacker) );		
				WRITE_BYTE( ENTINDEX(pVictim) );	
				WRITE_STRING( Weapon );	
				MESSAGE_END();
				
				UTIL_LogPrintf("\"%s<%d><%s><%s>\" killed \"%s<%d><%s><%s>\" with \"%s\"\n",
					STRING(pVictim->v.netname),
					GETPLAYERUSERID(pAttacker),
					GETPLAYERAUTHID(pAttacker),
					g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)( pAttacker ), "team"),
					STRING(pVictim->v.netname),
					GETPLAYERUSERID(pVictim),
					GETPLAYERAUTHID(pVictim),
					g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)( pVictim ), "team"),
					Weapon);
			}
			else if (pVictim != pAttacker)//Teamkill has no log line.
			{
				MESSAGE_BEGIN( MSG_ALL, gmsgDeathMsg );
				WRITE_BYTE( ENTINDEX(pAttacker) );	
				WRITE_BYTE( ENTINDEX(pVictim) );
				WRITE_STRING( "teammate" );
				MESSAGE_END();	
			}
			else //They killed themself. 
			{
				MESSAGE_BEGIN( MSG_ALL, gmsgDeathMsg );
				WRITE_BYTE( ENTINDEX(pAttacker) );		
				WRITE_BYTE( ENTINDEX(pVictim) );	
				WRITE_STRING( Weapon );	
				MESSAGE_END();
				
				UTIL_LogPrintf("\"%s<%d><%s><%s>\" committed suicide with \"%s\"\n",
					STRING(pVictim->v.netname),
					GETPLAYERUSERID(pVictim),
					GETPLAYERAUTHID(pVictim),
					g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)( pVictim ), "team"),
					Weapon);
			}

			BlockDeathMsg = 1;//Block the original "DeathMsg" and "committed suicide with world" Log line.
			MDLL_ClientKill(pVictim);//Kill the bastard.
			BlockDeathMsg = 0;//unblock messages.
			return 2;
		}
		else if(pVictim->v.health - Damage >= pVictim->v.max_health)
		{
			pVictim->v.health = pVictim->v.max_health;
		}
		else
		{
			pVictim->v.health -= Damage;
			return 1;
		}
	}
	else //Not a player, but do damage anyways
	{
		edict_t *pDamage = CREATE_NAMED_ENTITY(MAKE_STRING("trigger_hurt")); //Best way to do damage to other ents (I think!).
		pDamage->v.origin = Vector(RANDOM_LONG(10,15)*1000, 10000, 10000);
		MDLL_Spawn( pDamage );
		pDamage->v.dmg = Damage;
		pDamage->v.classname = MAKE_STRING(Weapon);
		MDLL_Touch(pDamage, pVictim);
		pDamage->v.flags = FL_KILLME;
	}
	return 0;
}